JasperReports Ultimate Guide - Sample Reference - Schema Reference - Configuration Reference - API (Javadoc)
JasperReports - Crosstabs Sample (version 5.6.0) |

Crosstab and subdataset sample.
Download All Sample Source Files
Browse Sample Source Files on SVN

Main Features in This Sample
| Crosstabs
| Datasets

top
| Crosstabs | Documented by
| Description / Goal |  | How to use the built-in crosstab element to display aggregated data.
| Since |  | 1.1.0
| Crosstabs Overview Crosstabs are very helpful tools used to aggregate data into 2-dimensional grids. Like other data aggregating elements (charts, for instance), they are organized as regular report elements, but with a complex structure and granularity. Crosstabs can be used with any level of data (nominal, ordinal, interval, or ratio), and usually display the summarized data, contained in report variables, in the form of a dynamic table. Variables are used to display aggregate data such as sums, counts, average values. Crosstabs are also interesting due to their flexible layout capabilities. When a crosstab does not fit on a page, then either a column or row break occurs, and the crosstab splits into several pieces. Depending on the remaining available space, the crosstab could continue on the same page, or it could overflow onto a new page. A crosstab element is characterized by the following attributes: `isRepeatColumnHeaders` - indicates whether the column headers should be placed in front of columns each time a row break occurs. The default value is `true`. `isRepeatRowHeaders` - indicates whether the row headers should be placed in front of rows each time a column break occurs. The default value is `true`. `columnBreakOffset` - when a column break occurs, indicates the amount of vertical space, measured in pixels, before the subsequent crosstab piece to be placed below the previous one on the same page. The default value is `10`. `runDirection` - indicates whether the crosstab data should be filled from left to right (`LTR`) or from right to left (`RTL`). The default value is `LTR`. `ignoreWidth` - indicates whether the crosstab will stretch beyond the initial crosstab width limit and dont't generate column breaks, or will stop rendering columns within the crosstab width limit and continue with the remaining columns only after all rows have started rendering. The default value is `false`. Crosstabs are also able to represent standalone data, not contained in variables. Any number of dynamic values can be passed from the enclosing report to the crosstab as crosstab parameters. A crosstab parameter is characterized by its `name` and `class` attributes and by the `<parameterValueExpression>` tag. One can declare crosstab parameters either one by one in the crosstab element, or grouping them in a parameters map referenced by the `<parametersMapExpression>` tag. Crosstab Datasets Like charts, crosstabs can handle by themselves collections of data. They can access data either in the report main dataset, or they can handle their own subdataset. All subdataset information required by the crosstab element is contained in the `<crosstabDataset>` child element. To faster perform calculations on data it is recommended that data come already sorted within dataset, according to the row and column groups. If this is not the case, then the crosstab internal engine should be instructed to sort data during the aggregation process. One can do this using the `isDataPreSorted` dataset attribute. If no `<crosstabDataset>` is declared, then the crosstab is using the main dataset. More on datasets can be found further in the datasets section. Data Grouping in Crosstab The crosstab calculation engine aggregates data by iterating through the associated dataset records. In order to aggregate data, one need to group them first. In a crosstab rows and columns are based on specific group items, called `buckets`. A bucket definition should contain: `bucketExpression` - the expression to be evaluated in order to obtain data group items `comparatorExpression` - needed in the case the natural ordering of the values is not the best choice `orderByExpression` - indicates the value used to sort data Row Groups Any number of row groups can be declared within a crosstab. The first row group will enclose the second one, the second one will enclose the third one, and so on. A row group is characterized by the following attributes: `name` - the name identifying the row group; this attribute is required. `width` - the width in pixels of the row group header `totalPosition` - specifies the position of the row containing total values relative to the row group. Possible values are: `Start`, `End`, `None`. The default value is `None`. `headerPosition` - specifies the position of the row header content when multiple enclosing row groups are declared. Possible values are: `Top`, `Middle`, `Bottom`, `Stretch`. The default value is `Top`. and contains the following elements: `<bucket>` `<crosstabRowHeader>` `<crosstabTotalRowHeader>` Column Groups Any number of column groups can be declared within a crosstab. Like row groups, outer column groups are enclosing inner column groups, in the same order as they were declared. A column group is characterized by the following attributes: `name` - the name identifying the column group; this attribute is required. `height` - the height in pixels of the column group header `totalPosition` - specifies the position of the column containing total values relative to the column group. Possible values are: `Start`, `End`, `None`. The default value is `None`. `headerPosition` - specifies the position of the column header content when multiple enclosing column groups are declared. Possible values are: `Left`, `Center`, `Right`, `Stretch`. The default value is `Left`. and contains the following elements: `<bucket>` `<crosstabColumnHeader>` `<crosstabTotalColumnHeader>` Measures A measure is a result of aggregate data calculation. Its value is typically displayed in the crosstab cells. A crosstab measure behaves just like a report variable and is completely characterized by: `name` - the name identifying the measure. `class` - specifies the measure object type. `calculation` - like for report variables, specifies one of the supported types of calculations, except `System`. The default value is `Nothing`. `incrementerFactoryClass` - the name of the incrementer factory class `percentageOf` - indicates if the calculation should be performed as percentage of some other total value (usually the crosstab grand total). `percentageCalculatorClass` - the name of a custom percentage calculator class. Built-in Crosstab Variables. Alternate Row/Column Colors The current value of a measure calculation is stored in a variable having the same name as the measure. `<Measure>_<Column Group>_ALL` - yields the total for all the entries in the column group from the same row. `<Measure>_<Row Group>_ALL` - yields the total for all the entries in the row group from the same column. `<Measure>_<Row Group>_<Column Group>_ALL` - yields the combined total corresponding to all the entries in both row and column groups `ROW_COUNT` - variable that counts the rows in a row group `COLUMN_COUNT` - variable that counts the columns in a column group Note: Based on the `ROW_COUNT` and `COLUMN_COUNT` one can generate alternate colors for rows or columns in a crosstab, using conditional styles:
    <style name="RowStyle" isDefault="false" mode="Opaque">
      <conditionalStyle>
        <conditionExpression><![CDATA[new Boolean($V{ROW_COUNT}.intValue() % 2 == 0)]] ></conditionExpression>
        <style backcolor="#E0E0E0"/>
      </conditionalStyle>
    </style>
or:
    <style name="ColumnStyle" isDefault="false" mode="Opaque">
      <conditionalStyle>
        <conditionExpression><![CDATA[new Boolean($V{COLUMN_COUNT}.intValue() % 2 == 0)]] ></conditionExpression>
        <style backcolor="#E0E0E0"/>
      </conditionalStyle>
    </style>
Crosstab Cells A crosstab cell is a rectangular report element that can contain any kind of other report element, except subreports, charts, and crosstabs. Usually, crosstab cells can be either detail cells (when its both row/column correspond to a bucket value), or total cells (when at least the row or column corresponds to a group total value). Depending on their position within the crosstab, or on their special meaning, crosstab cell types are described below: `<crosstabHeaderCell>` - this is the topmost left crosstab cell, where row headers and column headers meet. `<crosstabCell>` - these are the regular detail cells, with no `rowTotalGroup` or `columnTotalGroup` attribute declarations within their body. For these cells the `width` and `height` attributes are mandatory. `<crosstabCell>` - if at least the `rowTotalGroup` or `columnTotalGroup` declaration is present, this cell becomes a total cell. With a `rowTotalGroup` attribute, it will display a column total for that row group. With a `columnTotalGroup` attribute, it will display a row total for that column group. `<whenNoDataCell>` - if present, it specifies the content to be rendered instead, when the crosstab dataset has no data Crosstab JRXML Samples This sample contains 4 JRXML files illustrating various crosstab properties and usability. OrdersReport This report template shows how to use the most common crosstab features in order to represent aggregate data related to a set of shipment orders. The crosstab is placed in the report summary. It works with the report main dataset. It uses conditional styles based on the `ROW_COUNT` variable. Because data are not presorted, the engine performs internally data sorting, taking into account the `<orderByExpression>` criteria. It contains a single row group, bucketing the country names, and a single column group bucketing freight values. Detail cells contain multiple textfields with complementary information. Row and column headers are placed in the start position, and total rows and columns are placed on the last position in the crosstab. The crosstab do not split. LateOrdersReport The report uses settings already present in the `OrdersReport` template, but due to not enough available space on the page, the crosstab splits with a row break and continues on the next page. One can see that column headers are not repeated on the next page, because the `isRepeatColumnHeaders` is set to `false`. ProductsReport The crosstab is placed in the report detail section. It works with the `Customer_Quantity` subdataset. It uses settings already present in the `OrdersReport` template. A `<whenNoDataCell>` crosstab cell is declared within. If no records present in the dataset, the `No data` is printed instead. ShipmentsReport This is the most complex report sample. The crosstab is placed in the report detail section. It works with the `Country_Orders` subdataset. It uses settings already present in the above report templates. Depending on the available space the crosstab splits into multiple fragments, either by inserting column breaks, or row breaks. Row headers are repeating when columns break. Column headers are not repeating. The `<crosstabHeaderCell>` is present within the crosstab. Multiple row groups and column groups are declared. One can see how outer row headers are enclosing inner headers, and outer header columns are enclosing the inner headers. Also is shown the outer header cells content's behavior, relative to the available space in the header cell. Percentage calculations are performed in total cells. Running the Sample Running the sample requires the Apache Ant library. Make sure that `ant` is already installed on your system (version 1.5 or later). In a command prompt/terminal window set the current folder to `demo/hsqldb` within the JasperReports source project and run the `> ant runServer` command. It will start the HSQLDB server shipped with the JasperReports distribution package. Let this terminal running the HSQLDB server. Open a new command prompt/terminal window and set the current folder to `demo/samples/crosstabs` within the JasperReports source project and run the `> ant test view` command. It will generate all supported document types for the four sample reports and save them in the `demo/samples/crosstabs/build/reports` directory. Then the ShipmentsReport will open in the JasperReports internal viewer.
top
| Datasets | Documented by Sanda Zaharia
| Description / Goal |  | How to make use of subdatasets for chart elements and crosstab elements.
| Since |  | 1.1.0
| Other Samples |  |
/demo/samples/charts
| Report Datasets A dataset is an entity that intermediates data source and subreport characteristics. Datasets allow the engine to iterate through some virtual records, just as data sources do, but they also enable calculations and data grouping during this iteration using variables and groups. A dataset declaration, containing parameters, fields, variables, and groups, is similar to subreport declarations, but datasets are not related to any visual content. There are no sections or layout information at the dataset level. The report data source, along with the parameters, fields, variables, and groups declared at the report level, represent a special dataset declaration, implicitely used in every report template, the so-called main dataset. One can consider the main dataset responsible for iterating through the report data source records, calculating variables, filtering out records, and estimating group breaks during the report-filling process. Subdatasets and Dataset Runs User-defined datasets are declared as `<subDataset/>` elements. To completely characterize a subdataset one needs to set: Subdataset attributes: `name` `scriptletClass` `resourceBundle` `whenResourceMissingType` Subdataset elements: `<property/>` `<scriptlet/>` `<parameter/>` `<queryString/>` `<field/>` `<sortField/>` `<variable/>` `<filterExpression/>` `<group/>` Subdatasets are useful only in conjunction with some other complex elements, such as charts and crosstabs, that need to iterate through data not belonging to the main report data source itself, to retrieve specific data for the chart or perform data bucketing for the crosstab. Just simply declaring a dataset at the report level does not have any effect. The dataset has to be further referenced by a chart or crosstab element, in order to be used. Anytime a dataset is referenced by another report element, a dataset run is instantiated. A dataset run supplies additional information about either the appropriate data source to be iterated, or the database connection string. It comes also with its own parameters and/or parameters map. Dataset runs are similar to subreports in the way parameters and the data source/connection are passed in:
     <element name="datasetRun">
      <annotation>
       <documentation>Subdataset instantiation information for a chart/crosstab dataset.</documentation>
      </annotation>
      <complexType>
       <sequence>
        <element ref="jr:parametersMapExpression" minOccurs="0" maxOccurs="1"/>
        <element ref="jr:datasetParameter" minOccurs="0" maxOccurs="unbounded"/>
        <choice minOccurs="0" maxOccurs="1">
         <element ref="jr:connectionExpression"/>
         <element ref="jr:dataSourceExpression"/>
        </choice>
       </sequence>
       <attribute name="subDataset" type="string" use="required">
    	<annotation>
     	 <documentation>The name of the <elem>subdataset</elem> to instantiate.</documentation>
    	</annotation>
       </attribute>
      </complexType>
     </element>
The `subDataset` attribute is mandatory and contains the name of the subdataset to be used during the chart or crosstab filling process. If no dataset run is specified for a chart or crosstab, the main dataset of the report is used by default.

© 2001- Jaspersoft Corporation www.jaspersoft.com